%concatenate     [C] = concatenate(C1, C2, [C3])   concatenate Sillito matrices
%
%
%  rows(C) will be equal to rows(C1) + rows(C2) 
%
% can handle empty matrices gracefully
%
% see COMBINE

function [C] = concatenate(C1, C2, a1)
    
    if nargin > 2,
	C1 = concatenate(C1, C2);
	C = concatenate(C1, a1);
	return;
    end;
    
    
    if isempty(C1), C = C2; return; end;
    if isempty(C2), C = C1; return; end;
    
    maxnum = max([C1(:,1) ; C2(:,1)]);
    
    C = zeros(rows(C1)+rows(C2), maxnum+1);
    
    C(1:rows(C1), 1:(max(C1(:,1))+1)) = C1(:, 1:(max(C1(:,1))+1));

    C((rows(C1)+1):(rows(C1)+rows(C2)), 1:(max(C2(:,1))+1)) = ...
	C2(:, 1:(max(C2(:,1))+1));
    
    
    
    