% numspikes (C)		number of spikes in a raster of a Sillito-format matrix
%
% num = numspikes(C, [from=0], [to=Inf])
%
% Counts the number of spikes in rasters of a cell spike matrix C (which
% must be in a format as produced by rasterize). "num" will contain the same
% number of rows as C.
%
% The default is to count all spikes (in which case num == C(:,1)), but
% times (in ms) can also be specified.
%

function num = numspikes(C, from, to)
	
    if nargin < 2, to = Inf; end;
    if nargin < 2, from = 0; end;
    
    num = zeros(rows(C), 1);
    
    for r=1:rows(C),
	num(r) = ...
	    length(find(C(r,2:(C(r,1)+1)) >= from & C(r,2:(C(r,1)+1)) <= to));
    end;
