%This m file calls correlated_gen, initializes viables for IAF model, calls iafstdp_6inhLev, and makes output calculations.  Set parameters here.
%Was designed to be used with DCT toolbox, version 7.4 R2007a, a script can
%be written to make each call of this function a task, so same task can be
%run 25-30 times.  DCT_analyze can be used to plot output.
%Input needed to run function: factor_init and sigma1 and sigma2.  see line 118 for deatils on factor_init
%Output of simulation:  params saves parameter values used, including: ntrials(8), gmax(7), 
%                       rer saves final values in case need to loop again (ei, competition not completeed in number by ntrials)
%                       init saves starting initial synaptic weight values synW_end major output of model, synaptic weight values at end of simulation for all individual inputs
%                       cparams just labels params 
% To run simulation, type in command window: [cparams, synW_end, init, rer, params] =run_iafstdp_6inhLevs(1);
% Figure of final synaptic weight for both pathways for each inhibioty condition is generated for every run (a). 
% Save output by removing comment on line 255
 

function [cparams, synW_end, init, params,runName] = runBlueHelixIAF (factor_init, sigma1, sigma2)
    
 

   ntrials=2000;  %1200 or 2000
   runName= '11_02_2008histdepend_25percent'; %enter a name identifiers you want here
   T=2; %seconds of each trial 
  
  params(8,1)=ntrials;
  %note!  ntrials is NOT the same meaning as used in Kuhlman 2006 paper, in the paper, "simulation trial" means 1 run (which generally included ntrial=800)
  
  nin= 80;  % # of presyn inputs.   
  if rem(nin,2) ~= 0, error('# inputs must be an even number'); end
  %if nin>= ntrials*T*10, error('# inputs must be less than T*10 * ntrials'); end
              
  synW_end=zeros(nin,8);  % major output of model: final synaptic weights of all 80 inputs
  
   
   

%input set1, first half of inputs (ie, 1 through 40)
    r1=.75;             % correlation coefficient, constant at .5
       rate1= 20;      %units are Hz
          %sigma1= 3;   %units are ms
 %input set2, 2nd half of inputs (ie, 41 through 80)  
     r2=.75;            % correlation coefficient, constant at .5
       rate2= 20;      %units are Hz
          %sigma2= 6;   %units are ms
    
[mega, milli, nano,pico]=units;
gmax= 15*150*pico; %use 15 if 60-80 inputs total, ideally would have 200 inputs then gmax is simply 150*pico, but laptop does not have enough memory for 200 inputs
params(7,1)= gmax;

%----  the following are necessary to initialize and then loop simulation, looping- my solution to problem of not enough memory nopt enough memory ------
% 1 thourgh 6 are for 6 conditions (levels of inhibition in this case)
w1= zeros(nin,1);  w2= zeros(nin,1);  w3= zeros(nin,1);
w4= zeros(nin,1);  w5= zeros(nin,1);  w6= zeros(nin,1);
w7= zeros(nin,1);  w8= zeros(nin,1);% w= synaptic weight for each input
   
 

p1= zeros(nin,1); p2= zeros(nin,1); p3= zeros(nin,1);   % p= ammount of LTD if pre spike, same method as Song Miller Abbott 2000
m1= zeros(1,5);   m2= zeros(1,5);   m3= zeros(1,5);     % m= amount of LTP if post spike, same method as Song Miller Abbott 2000
v1= zeros(1,5);   v2= zeros(1,5);   v3= zeros(1,5);     % v= voltage of iaf neruon

p4= zeros(nin,1); p5= zeros(nin,1); p6= zeros(nin,1);
m4= zeros(1);   m5= zeros(1);   m6= zeros(1);
v4= zeros(1);   v5= zeros(1);   v6= zeros(1);

p7= zeros(nin,1);
m7= zeros(1);
v7= zeros(1);

p8= zeros(nin,1);
m8= zeros(1);
v8= zeros(1);

%--------------------------------------------------------------------------
%vm= zeros(1,ntrials*T*10000);
wInitialize= zeros(nin,1);  % variable for initial synapric weight values



 
     

%%%%%    begin loop  of ntrials (each trial = 20,000 iterations if T=2)  %%%%%

  for i =1:ntrials
  
    %[prespikes_Tot, params]= genPreSpikesTot (T, nin, r1, rate1, sigma1, r2,rate2, sigma2, params);
      %-----  generates presynaptic input and converts to long 0&1 format and presyn time output
  %----------------------------------        Set 1    ---------------------------------------
  [S1,sigma] = correlated_gen(T, nin/2, r1, 'rate',rate1, 'sigma',sigma1);   % run correlated_gen M file
  roundS= round(S1);
  [S1_rows, S1_cols] = size(roundS);
  %fprintf('length   heigth: %d, %d\n',S1_cols,S1_rows);
   
    %fprintf('Set1 avg rate per input: %d\n', sum(S1(:,1))/(nin/2)/T);
    params(10,1)= r1;    params(12,1)= rate1;    params(14,1)= sigma1;
   
  [prespikes_Tot]= sillito_converter (T,S1,nin);                      % run Sillito_converter M file
  
  %----------------------------------        Set 2    ---------------------------------------
   [S2,sigma] = correlated_gen(T, nin/2, r2, 'rate',rate2, 'sigma',sigma2);
   [H,W]= size(S2);
   roundS(nin/2+1:nin,1:W)= round(S2);
   [S_height, S_len] = size(roundS);
    
    %fprintf('Set2 avg rate per input: %d\n', sum(S2(:,1))/(nin/2)/T);
    params(11,1)= r2;    params(13,1)= rate2;    params(15,1)= sigma2;
   
%     if i==1,  prespiketimes= zeros(nin, S_len,ntrials); end  
%     prespiketimes(:, 1:S_len-1, i)= roundS(:,2:end);
    
    [prespikes_Tot2]= sillito_converter (T,S2,nin);
  prespikes_Tot (nin/2+1:nin,:)= prespikes_Tot2;

    
%%%%---------------------------------------------------------------------------------- 
  
 %----------  run IAF simulation
     %---- 
     %ISS ratio:    1   1.2   1.4       1.6     1.8      2.0    2.2     2.6     2.8      3.0    5.0
     %factor_init   1   .9129  0.8455   .7906  0.7457  0.7072  0.6745  0.6197  0.6203  0.5775  0.5000
     % can use the following formula to generate factor_init: y=1.0003 *(x^-.5003) where y is factor_init and x is ISS ratio (P2/P1)
     
     
     params(16,1)= factor_init;  %factor_init sets inital synaptic strength ratio (ISS), or relative strength between two pathways.  See table above for setting values.
 
     if i==1,
       wInitialize(1:nin/2,1)=distribute_wInit(nin)'*gmax*factor_init;  % initial synaptic weights for input set1
       wInitialize(nin/2+1:nin,1)= distribute_wInit(nin)'*gmax/factor_init;  % initial synaptic weights for input set 2
       init(1:length(wInitialize))= wInitialize';  %saves inital synaptic weight values
       
       pInit=0; mInit=0; vInit=-65*milli;
     end
   

  
        %-----------------  run iafstdp  Condition 1    --------------------------------- 
 
        %----- gain 1
        ifactor= 1.0;  %sets amplitude of individual inhibitory conducatnce, ifactor*.088*gmax
        
        params(20,1)=ifactor;
       
 
  if i~=1, wInitialize= w1; pInit= p1(:,1); mInit= m1(1); vInit= v1(1); end    %loops w into next trial 
 
 [w1(:,1),  p1(:,1), m1(1), v1(1),params(1:6,1)]=...
 iafstdp_8inhLev (T, prespikes_Tot, wInitialize, pInit, mInit, vInit, ifactor); %returns w at niter (final weight)


%-----------------  run iafstdp  Condition 2    ---------------------------------   

        ifactor= 2.0;  %sets amplitude of individual inhibitory conducatnce, ifactor*.088*gmax
        
        params(23,1)=ifactor;
        
   if i~=1, wInitialize= w2; pInit= p2(:,1); mInit= m2(1); vInit= v2(1); end
 
 [w2(:,1),  p2(:,1), m2(1), v2(1),params(1:6,1)]=...
 iafstdp_8inhLev (T, prespikes_Tot, wInitialize, pInit, mInit, vInit, ifactor); %returns w at niter (final weight)
     
    

 
  
  
   
  %-----------------  run iafstdp  Condition 3    ---------------------------------   
    
        ifactor= 3.0;  %sets amplitude of individual inhibitory conducatnce, ifactor*.088*gmax
       
        params(26,1)=ifactor;
        
 if i~=1, wInitialize= w3; pInit= p3(:,1); mInit= m3(1); vInit= v3(1); end
 
 [w3(:,1), p3(:,1), m3(1), v3(1), params(1:6,1)]=...
 iafstdp_8inhLev (T, prespikes_Tot, wInitialize, pInit, mInit, vInit, ifactor); %returns w at niter (final weight)
  
    
   


  %-----------------  run iafstdp  Condition 4    ---------------------------------   
      
        ifactor= 4.0;  %sets amplitude of individual inhibitory conducatnce, ifactor*.088*gmax
        
        params(29,1)=ifactor;
        
 if i~=1, wInitialize= w4; pInit= p4(:,1); mInit= m4(1); vInit= v4(1); end
 
 [w4(:,1), p4(:,1), m4(1), v4(1), params(1:6,1)]=...
 iafstdp_8inhLev (T, prespikes_Tot, wInitialize, pInit, mInit, vInit, ifactor); %returns w at niter (final weight)
  
    
 %-----------------  run iafstdp  Condition 5    ---------------------------------   
   
        ifactor= 5.0;  %sets amplitude of individual inhibitory conducatnce, ifactor*.088*gmax
       
        params(32,1)=ifactor;
        
 if i~=1, wInitialize= w5; pInit= p5(:,1); mInit= m5(1); vInit= v5(1); end
 
 [w5(:,1),  p5(:,1), m5(1), v5(1),params(1:6,1)]=...
 iafstdp_8inhLev (T, prespikes_Tot, wInitialize, pInit, mInit, vInit, ifactor); %returns w at niter (final weight)
 
   
    
  
    %-----------------  run iafstdp  Condition 6    ---------------------------------   
     
        ifactor= 6.0;  %sets amplitude of individual inhibitory conducatnce, ifactor*.088*gmax
        
        params(35,1)=ifactor;
        
 if i~=1, wInitialize= w6; pInit= p6(:,1); mInit= m6(1); vInit= v6(1); end
 
 [w6(:,1),   p6(:,1), m6(1), v6(1),params(1:6,1)]=...
 iafstdp_8inhLev (T, prespikes_Tot, wInitialize, pInit, mInit, vInit, ifactor); %returns w at niter (final weight)
  
    
      
 
  
 %-----------------  run iafstdp  Condition 7    ---------------------------------   
   
        ifactor= 7.0;  %sets amplitude of individual inhibitory conducatnce, ifactor*.088*gmax
        
        params(38,1)=ifactor;
        
 if i~=1, wInitialize= w7; pInit= p7(:,1); mInit= m7(1); vInit= v7(1); end
 
 [w7(:,1),   p7(:,1), m7(1), v7(1),params(1:6,1)]=...
 iafstdp_8inhLev (T, prespikes_Tot, wInitialize, pInit, mInit, vInit, ifactor); %returns w at niter (final weight)
  
   
     
  
    %%%%-----------------  run iafstdp  Condition 8    ---------------------------------   
     
        ifactor= 8.0;  %sets amplitude of individual inhibitory conducatnce, ifactor*.088*gmax
       
        params(41,1)=ifactor;
        
 if i~=1, wInitialize= w8; pInit= p8(:,1); mInit= m8(1); vInit= v8(1); end
 
 [w8(:,1),  p8(:,1), m8(1), v8(1),params(1:6,1)]=...
 iafstdp_8inhLev (T, prespikes_Tot, wInitialize, pInit, mInit, vInit, ifactor); %returns w at niter (final weight)
 
   



  
  
    %%%%%fprintf(' %d of %d trials complete.  Spike rate(Hz) %d \n\n', i,ntrials, spike_count/2);    
    
     %---------------------------------------------------------------------   

  
%   fname='tempData8levs';
% %save(fname, 'synW_end', 'init', 'rer', 'params');  
  
  end
  
  synW_end(1:nin,1)= w1;
  synW_end(1:nin,2)= w2;
  synW_end(1:nin,3)= w3;
  synW_end(1:nin,4)= w4;
  synW_end(1:nin,5)= w5;
  synW_end(1:nin,6)= w6;
  synW_end(1:nin,7)= w7;
  synW_end(1:nin,8)= w8;
 




%string labelling what params are saved:
cparams= char( 'gmax [1]', 'gmin [2]', 'capacitance [3]', 'gleak[4]','delay [5]','randnoise[6]',...
                'gmax[7]', 'ntrials [8]','','r 1 [10]', 'r 2[11]', 'rate 1 [12]', 'rate 2 [13]',...
                'sigma 1[14]', 'sigma 2[15]', 'isiFacotr[16]', ...
                'iFactor [20,1]', 'gain [20,2]', 'iTau [20,3]',...
                'iFactor [21,1]', 'gain [21,2]', 'iTau [21,3]',...
                'iFactor [22,1]', 'gain [22,2]', 'iTau [22,3]',...
                'iFactor [23,1]', 'gain [23,2]', 'iTau [23,3]',...
                'iFactor [24,1]', 'gain [24,2]', 'iTau [24,3]',...
                'iFactor [25,1]', 'gain [25,2]', 'iTau [25,3]',...
                'iFactor [26,1]', 'gain [26,2]', 'iTau [26,3]',...
                'iFactor [27,1]', 'gain [27,2]', 'iTau [27,3]',...
                'iFactor [28,1]', 'gain [28,2]', 'iTau [28,3]'...
                );



%-----------------------------------------------------------

return;