%Presynaptic input parameters can be modified here (line 14-19).  This m file calls correlated_gen, initializes STDPiaf.m, and makes output calculations
%generates 2 figures.


function tutorial_iafstdp

  T=2; %seconds of each trial 
  ntrials= 100;  % T*ntrials number of iterations.  Note, this ntrials is NOT same as number of simulation runs.
  nin= 80;  %# of presyn inputs  must be even number
              if nin>= ntrials*T*10, error('# inputs must be less than T*10 * ntrials'); end
              if rem(nin,2) ~= 0, error('# inputs must be an even number'); end

    r1=.75;
       rate1= 20;      %Hz
          sigma1= 3;  %ms
    r2=.75;
       rate2= 20;      %Hz
          sigma2= 6;  %ms
    
[mega, milli, nano,pico]=units;
gmax= 15*150*pico; %use 15* if 80 inputs total, can reduce if use more inputs




w0= zeros(nin,ntrials);
mps= zeros(14,T*10);
mps(9,15)=ntrials;

spike_count0= zeros(1,ntrials); 
gI0=zeros(1,ntrials);   
p0= zeros(nin,ntrials); 
m0= zeros(1,ntrials);  
v0= zeros(1,ntrials);  
synW0= zeros(nin,ntrials);
wInitialize= zeros(nin,1);
 
     
%%%%%    begin loop  of ntrials (each trial = T * 10,000 iterations)  %%%%%

for i =1:ntrials
  %-----  generates presynaptic input and converts to long 0&1 format and presyn time output
  %----------------------------------        Set 1    ---------------------------------------
  [S1,sigma] = correlated_gen(T, nin/2, r1, 'rate',rate1, 'sigma',sigma1);   % run correlated_gen M file
   
    mps(10,i)= sum(S1(:,1))/(nin/2)/T;    fprintf('Set1 avg rate per input: %d\n', mps(10,i));
    mps (9,1)= r1;    mps (9,3)= rate1;    mps (9,5)= sigma1;
   
  [prespikes_Tot]= sillito_converter (T,S1,nin);                      % run Sillito_converter M file
  
  %----------------------------------        Set 2    ---------------------------------------
   [S2,sigma] = correlated_gen(T, nin/2, r2, 'rate',rate2, 'sigma',sigma2);
    
    mps(11,i)= sum(S2(:,1))/(nin/2)/T;    fprintf('Set2 avg rate per input: %d\n', mps(11,i));
    mps (9,2)= r2;    mps (9,4)= rate2;    mps (9,6)= sigma2;
    
    [prespikes_Tot2]= sillito_converter (T,S2,nin);
   prespikes_Tot (nin/2+1:nin,:)= prespikes_Tot2;
%%%%---------------------------------------------------------------------------------- 
  
 %----------  run IAF simulation
 
 
   %----- Initialize synaptic weight
  if i==1, 
       wInitialize(1:nin/2,1)=distribute_wInit(nin)'*gmax; wInitialize(nin/2+1:nin,1)= distribute_wInit(nin)'*gmax;
       mps(12, 1:length(wInitialize))= wInitialize'; pInit=0; mInit=0; vInit=-65*milli;
   end
  
   
        %-----------------  run SongSTDP  --------------------------------- 
  
 ifactor= 3;  %corrisponds to 0.26 gI/gMaxex
 
 mps(9,7)=ifactor;  
 
  if i~=1, wInitialize= w0(:,i-1); pInit= p0(:,i-1); mInit= m0(i-1); vInit= v0(i-1); end    %loops w into next trial 
 
 [w0(:,i), p0(:,i), m0(i), v0(i),w_MP, ExI_MP, InhI_MP, spike_count, nspike, params, v_mem, gE,gI, stimes]=...
 iafstdp (T, prespikes_Tot, wInitialize, pInit, mInit, vInit, ifactor); %returns w at niter (final weigth)
      
      spike_count0(i)= spike_count;
    
      p= 1+ ((i -1)*(T*10));
      q= 1+ ((i -1)*(T*1000*10));
      compIndex= mean (w_MP (nin/2+1:nin,:)) - mean (w_MP (1:nin/2,:)); % differnce of means
      mps(2,p:p-1+length(compIndex))= compIndex;
    
      mps(1,p:p-1+length(nspike))= nspike;
      
      mps(3,p:p-1+length(w_MP (1,:)))= mean (w_MP (1:nin/2,:));   %  set 1  condiiton 1
      mps(4,p:p-1+length(w_MP (1,:)))= mean (w_MP (nin/2+1:nin,:));   %  set 2  condiiton 1
      mps(5,i)= spike_count/T;  %spikes per sec condition 1
      mps(6,i)= gI0(i);
      mps(7,1:nin)= (w_MP (:,end))';
      mps(13,p:p-1+length(ExI_MP))= ExI_MP;
      mps(14,p:p-1+length(InhI_MP))= InhI_MP;
      synW0(:,i)= w_MP (:,end);
      totalv_mem(1,q:q-1+length(v_mem))=v_mem;
      totalgE(1,q:q-1+length(gE))=gE;
      totalgI(1,q:q-1+length(gI))=gI;
 

  fprintf('  %d of %d trials complete\n\n', i,ntrials);    
 end     
     %---------------------------------------------------------------------   

  
  %--------- Params
  mps(9,9:14)= params';

  
   %---transpose
     mps=mps'; 
     
 
%-------------- plot figure 1 demo
 x=.1:.1:length(totalv_mem)*.1; %ms
 j=(1:100:(ntrials*T*1000));  %x axis in ms, 1:100 ms bin:total ms of simulated time
figure(1); subplot (3,1,1); plot(x,totalv_mem*10^3); ylabel(' membrane potential (mV)');
           subplot (3,1,3); plot(x,totalgE/nano,x,totalgI/nano); legend ('conductance Ex','conductance Inh');...
               ylabel('nanoSiemens'); xlabel('simulated time (ms)');
           subplot (3,1,2); plot(j, mps(:,13)/pico,j,mps(:,14)/pico);legend('current Ex', 'current Inh'); ylabel('picoAmps');
%-------------- plot figure 2 

j2=(1:(T):(ntrials*T));  % in seconds, for post spike rate
j3=(.2/T:(.2/T):(ntrials*T));  % in seconds, for syn weight plot
 figure(2) ;
         subplot (2,1,1); plot ( j2, mps(1:ntrials,5),'k', 'linewidth', 2); ylabel('post spikes per sec');
                                                                               xlabel('simulated time (seconds)');
         subplot (2,1,2); plot  (j3, mps(:,3)/gmax,'r', ...
                                 j3, mps(:,4)/gmax, 'b', 'linewidth', 2); ylabel('g/gmax ex');
                                 xlabel('simulated time (seconds)');


return;