%zpsth       [p, s] = zpsth(C, nbins, from, to)
%
%
% Does raw psth's. Values are returned without normalising by
% nrasters. Implemented as a mex file. p is the psths (means), s
% is the sum of squared number of spikes.
%
% binwidth will be ((to+1e-5)-from)/nbins. There is a bin edge at
% to. 
%
% ALL VALUES ARE RETURNED RAW, WITHOUT NORMALISING OR DIVIDING BY
% NRASTERS. 


% the following m-file should only run if the mex file is not
% existent. 

function [p, s] = zpsth(C, nbins, from, to)
   
   binwidth = ((to+1e-5)-from)/nbins;
   
   nrasters = rows(C);
   
   p = zeros(1, nbins);
   s = zeros(1, nbins);
   
   
   for raster = 1:nrasters,

      v = zeros(1, nbins);

      for spike=2:(C(raster,1)+1),
	 time = C(raster, spike);
	 if time > to, break; end;
	 if time >= from,
	    bin = floor((time-from)/binwidth) + 1;
	    p(bin) = p(bin)+1;
	    v(bin) = v(bin)+1;
	 end;
      end;
   
      s = s + v.*v;
   end;
   